## [PureMVC](http://puremvc.github.com/) Dart MultiCore Framework
PureMVC is a lightweight framework for creating applications based upon the classic [Model-View-Controller](http://en.wikipedia.org/wiki/Model-view-controller) design meta-pattern. This is a Dart port of the [AS3 reference implementation of the MultiCore Version](https://github.com/PureMVC/puremvc-as3-multicore-framework/wiki). It supports [modular programming](http://en.wikipedia.org/wiki/Modular_programming) through the use of [Multiton](http://en.wikipedia.org/wiki/Multiton) Core actors.

Unit Tests are included in this repository.

To use in your app, you can simply [add it to your project's pubspec.yaml as a dependency](http://pub.dartlang.org/packages/puremvc).

* [API Docs](http://darkstar.puremvc.org/content_header.html?url=http://puremvc.org/pages/docs/Dart/multicore/puremvc.html&desc=PureMVC%20API%20Docs:%20PureMVC%20MultiCore%20for%20Dart)
* [Discussion](http://forums.puremvc.org/index.php?board=98.0)
* [Live Unit Test Runner](http://darkstar.puremvc.org/content_header.html?url=http://puremvc.org/pages/demos/Dart/PureMVC_Dart_Unit_Tests/Unit_Tests.html&desc=PureMVC%20MultiCore%20for%20Dart:%20Unit%20Tests)
* [Overview Presentation](http://puremvc.tv/#P002)
* [Circle us on Google Plus](http://google.com/+puremvc)

## Demos
* [Reverse Text](https://github.com/PureMVC/puremvc-dart-demo-reversetext/wiki)

## Status
Production - [Version 2.0.5](https://github.com/PureMVC/puremvc-dart-multicore-framework/blob/master/VERSION)

## Platforms / Technologies
* [Google Dart](http://www.dartlang.org)

## License
* PureMVC MultiCore Framework for Dart (Ported) - Copyright © 2013 Cliff Hall
* PureMVC - Copyright © 2006-2013 [Futurescale, Inc](http://futurescale.com).
* All rights reserved.

* Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
  * Neither the name of Futurescale, Inc., PureMVC.org, nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
